<template>
  <div class="flex flex-col">
    <a-input label="Name:" placeholder="name" :validators="nameValidators"
      v-model="event.name" />
    <Selector title="Lodge id:" :options="lodges_ids" v-model="event.lodge_id"
      :defaultOption="event.lodge_id" />
    <a-input label="Date:" placeholder="dd/mm/yyyy" :validators="dateValidators"
      v-model="event.date" />
    <a-input label="Description:" placeholder="description"
      :validators="descriptionValidators" v-model="event.description" />
    <div class="flex justify-center">
      <SubmitButton value="post" @click="submit" />
      <CancelButton value="cancel" @click="cancel" />
    </div>
  </div>
</template>

<script>
import { useRoute } from 'vue-router';
import { mapGetters } from 'vuex';
import AInput from '@/components/AInput.vue';
import Selector from '@/components/Selector.vue';
import SubmitButton from '@/components/SubmitButton.vue';
import CancelButton from '@/components/CancelButton.vue'
import { emptyValidator, dateValidator } from '@/components/Validators.js'
import axiosClient from '@/axiosClient';
import { convertStrToTimestamp } from '@/components/helpers';

export default {
  components: {
    AInput,
    Selector,
    SubmitButton,
    CancelButton
  },
  data() {
    return {
      event: {},
      nameValidators: [emptyValidator],
      dateValidators: [dateValidator],
      descriptionValidators: [emptyValidator],
      new: false,
      lodges_ids: []
    }
  },
  methods: {
    submit() {
      if (this.new) {
        this.create()
      }
      else {
        this.update()
      }
    },
    create() {
      const payload = JSON.stringify({
        data: {
          attributes: {
            name: this.event.name,
            date: convertStrToTimestamp(this.event.date),
            description: this.event.description,
            lodge_id: Number(this.event.lodge_id),
          }
        }
      })

      axiosClient.post('/events', payload)
        .then(() => {
          this.$router.go(-1)
        })
    },
    update() {
      const payload = JSON.stringify({
        data: {
          attributes: {
            new_name: this.event.name,
            new_date: convertStrToTimestamp(this.event.date),
            new_description: this.event.description,
            new_lodge_id: Number(this.event.lodge_id),
          }
        }
      })

      axiosClient.patch(`/events/${this.event.id}`, payload)
        .then(() => {
          this.$router.go(-1)
        })
    },
    cancel() {
      this.$router.go(-1)
    }
  },
  computed: {
    ...mapGetters({
      eventById: "getEvent",
    })
  },
  mounted() {
    if (useRoute().params.id != 'new') {
      Object.assign(this.event = this.eventById(useRoute().params.id))
    } else {
      this.new = true
      this.event.lodge_id = 1
    }
    axiosClient.get('/lodges')
      .then((response) => {
        for (let lodge_data of response.data.data) {
          this.lodges_ids.push(lodge_data.id)
        }
      })
  }
}

</script>